﻿Imports EnumInstalledPrograms

Public Class Form1

    Private Delegate Sub Dlgt(ByVal Results As List(Of InstalledProgram))

    Private Structure Args
        Dim ComputerName As String
        Dim IncludeUpdates As Boolean
    End Structure

    Private Sub PopulateBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PopulateBtn.Click
        Me.Enabled = False
        ProgramsFoundLbl.Text = CStr(0)
        Progbar.Style = ProgressBarStyle.Marquee
        'Get rid of anything that was in the listview
        ProgramsLvw.Items.Clear()
        Dim Arg As New Args
        Arg.ComputerName = ComputerNameBox.Text
        Arg.IncludeUpdates = IncludeChk.Checked
        'Start the enumeration process on a background thread
        Dim bgthread As New Threading.Thread(AddressOf BG_GetPrograms)
        bgthread.IsBackground = True
        bgthread.Start(Arg)
    End Sub

    'This method is run on a background thread so that the UI does not freeze
    Private Sub BG_GetPrograms(ByVal Arguments As Object)
        Dim Arg As Args = DirectCast(Arguments, Args)
        Dim InstalledPrograms As List(Of InstalledProgram) = InstalledProgram.GetInstalledPrograms(Arg.ComputerName, Arg.IncludeUpdates)
        Me.Invoke(New Dlgt(AddressOf GetProgramsFinished), InstalledPrograms)
    End Sub

    Private Sub GetProgramsFinished(ByVal InstalledPrograms As List(Of InstalledProgram))
        If Not InstalledPrograms Is Nothing Then
            For i As Integer = 0 To InstalledPrograms.Count - 1
                Dim Lvi As New ListViewItem(InstalledPrograms(i).DisplayName)
                Lvi.SubItems.Add(New ListViewItem.ListViewSubItem(Lvi, InstalledPrograms(i).Version))
                If InstalledPrograms(i).IsUpdate Then
                    If UpdatesOnlyChk.Checked OrElse IncludeChk.Checked Then
                        Lvi.SubItems.Add(New ListViewItem.ListViewSubItem(Lvi, "Yes"))
                        ProgramsLvw.Items.Add(Lvi)
                    End If
                Else 'Not an update
                    If Not UpdatesOnlyChk.Checked Then
                        Lvi.SubItems.Add(New ListViewItem.ListViewSubItem(Lvi, "No"))
                        ProgramsLvw.Items.Add(Lvi)
                    End If
                End If
                Lvi.SubItems.Add(New ListViewItem.ListViewSubItem(Lvi, InstalledPrograms(i).UninstallString))
            Next
        End If
        Me.Enabled = True
        Progbar.Style = ProgressBarStyle.Blocks
        If ProgramsLvw.Items.Count = 0 Then
            MessageBox.Show("No programs were found - this could either be because the computer you specified could not be contacted, " & _
                            "or because there were no programs installed on the computer (that is not very likely really though is it)." & vbNewLine & _
                            "Try again... but this time type the computer name correctly.", "Oh Dear", MessageBoxButtons.OK, MessageBoxIcon.Warning)
        Else
            ProgramsFoundLbl.Text = ProgramsLvw.Items.Count.ToString
        End If
    End Sub

    Private Sub UpdatesOnlyChk_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdatesOnlyChk.CheckedChanged
        IncludeChk.Enabled = Not UpdatesOnlyChk.Checked
        IncludeChk.Checked = UpdatesOnlyChk.Checked
    End Sub
End Class
